Index: java/main/src/main/java/com/framsticks/communication/ClientConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/ClientConnection.java	(revision 84)
@@ -8,10 +8,12 @@
 import com.framsticks.params.ListSource;
 import com.framsticks.util.*;
+import com.framsticks.util.dispatching.AtOnceDispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 import org.apache.log4j.Logger;
 
-import java.io.BufferedReader;
 import java.io.IOException;
-import java.io.InputStreamReader;
-import java.io.PrintWriter;
 import java.net.Socket;
 import java.net.SocketException;
@@ -25,367 +27,368 @@
 public class ClientConnection extends Connection {
 
-    private final static Logger LOGGER = Logger.getLogger(ClientConnection.class);
-
-    protected final Map<String, Subscription> subscriptions = new HashMap<String, Subscription>();
-
-    public String getAddress() {
-        return address;
-    }
-
-    public void connect(StateFunctor connectedFunctor) {
-        try {
-            LOGGER.info("connecting to " + address);
-
-            socket = new Socket(hostName, port);
-
-            socket.setSoTimeout(500);
-
-            LOGGER.info("connected to " + hostName + ":" + port);
-            connected = true;
-
-            runThreads();
-
-            connectedFunctor.call(null);
-        } catch (SocketException e) {
-            LOGGER.error("failed to connect: " + e);
-            connectedFunctor.call(e);
-        } catch (IOException e) {
-            LOGGER.error("buffer creation failure");
-            connectedFunctor.call(e);
-            close();
-        }
-    }
-
-    private static abstract class InboundMessage {
-        protected String currentFilePath;
-        protected List<String> currentFileContent;
-        protected final List<File> files = new ArrayList<File>();
-
-        public abstract void eof();
-
-        protected void initCurrentFile(String path) {
-            currentFileContent = new LinkedList<String>();
-            currentFilePath = path;
-        }
-        protected void finishCurrentFile() {
-            if (currentFileContent == null) {
-                return;
-            }
-            files.add(new File(currentFilePath, new ListSource(currentFileContent)));
-            currentFilePath = null;
-            currentFileContent= null;
-        }
-
-        public abstract void startFile(String path);
-
-        public void addLine(String line) {
-            assert line != null;
-            assert currentFileContent != null;
-            currentFileContent.add(line.substring(0, line.length() - 1));
-        }
-
-        public List<File> getFiles() {
-            return files;
-        }
-    }
-
-    private static class EventFire extends InboundMessage {
-        public final Subscription subscription;
-
-        private EventFire(Subscription subscription) {
-            this.subscription = subscription;
-        }
-
-        public void startFile(String path) {
-            assert path == null;
-            initCurrentFile(null);
-        }
-
-        @Override
-        public void eof() {
-            finishCurrentFile();
-            Dispatching.invokeLaterOrNow(subscription.getDispatcher(), new Runnable() {
-                @Override
-                public void run() {
-                    subscription.getEventCallback().call(getFiles());
-                }
-            });
-        }
-    }
-
-    private static class SentQuery extends InboundMessage {
-        Request request;
-        ResponseCallback callback;
-        Dispatcher dispatcher;
-
-        public void startFile(String path) {
-            finishCurrentFile();
-            if (path == null) {
-                assert request instanceof ApplicationRequest;
-                path = ((ApplicationRequest)request).getPath();
-            }
-            initCurrentFile(path);
-        }
-
-        public void eof() {
-            finishCurrentFile();
-            //no-operation
-        }
-
-        @Override
-        public String toString() {
-            return request.toString();
-        }
-    }
-    private Map<Integer, SentQuery> queryMap = new HashMap<Integer, SentQuery>();
-
-
-    protected final String address;
-    protected final String hostName;
-    protected final int port;
-
-    private static Pattern addressPattern = Pattern.compile("^([^:]*)(:([0-9]+))?$");
-
-    public ClientConnection(String address) {
-        assert address != null;
-        this.address = address;
-        Matcher matcher = addressPattern.matcher(address);
-        if (!matcher.matches()) {
-            LOGGER.fatal("invalid address: " + address);
-            hostName = null;
-            port = 0;
-            return;
-        }
-        hostName = matcher.group(1);
-        port = matcher.group(3) != null ? Integer.parseInt(matcher.group(3)) : 9009;
-    }
-
-    private SentQuery currentlySentQuery;
-
-    public void send(Request request, ResponseCallback callback) {
-        send(request, AtOnceDispatcher.instance, callback);
-    }
-
-    public void send(Request request, Dispatcher dispatcher, ResponseCallback callback) {
-
-        if (!isConnected()) {
-            LOGGER.fatal("not connected");
-            return;
-        }
-        final SentQuery sentQuery = new SentQuery();
-        sentQuery.request = request;
-        sentQuery.callback = callback;
-        sentQuery.dispatcher = dispatcher;
-
-        senderThread.invokeLater(new Runnable(){
-            @Override
-            public void run() {
-                synchronized (ClientConnection.this) {
-
-                    while (!(requestIdEnabled || currentlySentQuery == null)) {
-                        try {
-                            ClientConnection.this.wait();
-                        } catch (InterruptedException ignored) {
-                            break;
-                        }
-                    }
-                }
-                Integer id = stashQuery(sentQuery);
-                String command = sentQuery.request.getCommand();
-                StringBuilder message = new StringBuilder();
-                message.append(command);
-                if (id != null) {
-                    message.append(" ").append(id);
-                }
-                sentQuery.request.construct(message);
-                String out = message.toString();
-
-                output.println(out);
-                LOGGER.debug("sending query: " + out);
-
-            }
-        });
-        /*
-        synchronized (this) {
-            LOGGER.debug("queueing query: " + query);
-            queryQueue.offer(sentQuery);
-            notifyAll();
-        }
-        */
-    }
-
-
-    @Override
-    public String toString() {
-        return address;
-    }
-
-    public void subscribe(final String path, final SubscriptionCallback callback) {
-        send(new RegistrationRequest().setPath(path), new ResponseCallback() {
-            @Override
-            public void process(Response response) {
-                if (!response.getOk()) {
-                    LOGGER.error("failed to register on event: " + path);
-                    callback.subscribed(null);
-                    return;
-                }
-                assert response.getFiles().isEmpty();
-                Subscription subscription = new Subscription(ClientConnection.this, path, response.getComment());
-                LOGGER.debug("registered on event: " + subscription);
-                synchronized (subscriptions) {
-                    subscriptions.put(subscription.getRegisteredPath(), subscription);
-                }
-                subscription.setEventCallback(callback.subscribed(subscription));
-                if (subscription.getEventCallback() == null) {
-                    LOGGER.info("subscription for " + path + " aborted");
-                    subscription.unsubscribe(new LoggingStateCallback(LOGGER, "abort subscription"));
-                }
-            }
-        });
-    }
-
-    public void negotiateProtocolVersion(StateFunctor stateFunctor) {
-        protocolVersion = -1;
-        sendQueryVersion(1, stateFunctor);
-    }
-
-    public void sendQueryVersion(final int version, final StateFunctor stateFunctor) {
-        send(new VersionRequest().version(version), new StateCallback() {
-            @Override
-            public void call(Exception e) {
-                if (e != null) {
-                    LOGGER.fatal("failed to upgrade protocol to version: " + version);
-                    return;
-                }
-                protocolVersion = version;
-                if (version < 4) {
-                    /** it is an implicit loop here*/
-                    sendQueryVersion(version + 1, stateFunctor);
-                    return;
-                }
-                send(new UseRequest().feature("request_id"), new StateCallback() {
-                    @Override
-                    public void call(Exception e) {
-                        requestIdEnabled = e == null;
-                        /*
-                        synchronized (ClientConnection.this) {
-                            ClientConnection.this.notifyAll();
-                        }
-                        */
-                        if (!requestIdEnabled) {
-                            LOGGER.fatal("protocol negotiation failed");
-                            stateFunctor.call(new Exception("protocol negotiation failed", e));
-                            return;
-                        }
-                        stateFunctor.call(null);
-                    }
-                });
-
-            }
-        });
-    }
-
-
-    private synchronized SentQuery fetchQuery(Integer id, boolean remove) {
-        if (id == null) {
-            if (requestIdEnabled) {
-                return null;
-            }
-            SentQuery result = currentlySentQuery;
-            if (remove) {
-                currentlySentQuery = null;
-                notifyAll();
-            }
-            return result;
-        }
-        if (queryMap.containsKey(id)) {
-            SentQuery result = queryMap.get(id);
-            if (remove) {
-                queryMap.remove(id);
-            }
-            return result;
-        }
-        return null;
-    }
-
-    private int nextQueryId = 0;
-
-    private Integer stashQuery(SentQuery sentQuery) {
-        if (!requestIdEnabled) {
-            currentlySentQuery = sentQuery;
-            return null;
-        }
-        queryMap.put(nextQueryId, sentQuery);
-        return nextQueryId++;
-    }
-
-    protected void processMessage(InboundMessage inboundMessage) throws Exception {
-        if (inboundMessage == null) {
-            LOGGER.error("failed to use any inbound message");
-            return;
-        }
-
-        String line;
-        while (!(line = getLine()).startsWith("eof")) {
-            inboundMessage.addLine(line);
-        }
-        inboundMessage.eof();
-    }
-
-    protected void processEvent(String rest) throws Exception {
-        Matcher matcher = eventPattern.matcher(rest);
-        if (!matcher.matches()) {
-            LOGGER.error("invalid event line: " + rest);
-            return;
-        }
-        Subscription subscription = subscriptions.get(matcher.group(1));
-        if (subscription == null) {
-            LOGGER.error("non subscribed event: " + matcher.group(1));
-            return;
-        }
-        EventFire event = new EventFire(subscription);
-        event.startFile(null);
-        processMessage(event);
-    }
-
-
-    protected void processMessageStartingWith(String line) throws Exception {
-        Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
-        if (command.first.equals("event")) {
-            processEvent(command.second);
-            return;
-        }
-        Pair<Integer, String> rest = parseRest(command.second);
-
-        if (command.first.equals("file")) {
-            SentQuery sentQuery = fetchQuery(rest.first, false);
-            sentQuery.startFile(rest.second);
-            processMessage(sentQuery);
-            return;
-        }
-
-        SentQuery sentQuery = fetchQuery(rest.first, true);
-        if (sentQuery == null) {
-            return;
-        }
-        LOGGER.debug("parsing response for request " + sentQuery);
-
-        final Response response = new Response(command.first.equals("ok"), rest.second, sentQuery.getFiles());
-        final ResponseCallback callback = sentQuery.callback;
-
-        Dispatching.invokeLaterOrNow(sentQuery.dispatcher, new Runnable() {
-            @Override
-            public void run() {
-                callback.process(response);
-            }
-        });
-    }
-
-    @Override
-    protected void receiverThreadRoutine() throws Exception {
-        while (connected) {
-            processMessageStartingWith(getLine());
-        }
-    }
+	private final static Logger log = Logger.getLogger(ClientConnection.class);
+
+	protected final Map<String, Subscription> subscriptions = new HashMap<String, Subscription>();
+
+	public String getAddress() {
+		return address;
+	}
+
+	public void connect(StateFunctor connectedFunctor) {
+		try {
+			log.info("connecting to " + address);
+
+			socket = new Socket(hostName, port);
+
+			socket.setSoTimeout(500);
+
+			log.info("connected to " + hostName + ":" + port);
+			connected = true;
+
+			runThreads();
+
+			connectedFunctor.call(null);
+		} catch (SocketException e) {
+			log.error("failed to connect: " + e);
+			connectedFunctor.call(e);
+		} catch (IOException e) {
+			log.error("buffer creation failure");
+			connectedFunctor.call(e);
+			close();
+		}
+	}
+
+	private static abstract class InboundMessage {
+		protected String currentFilePath;
+		protected List<String> currentFileContent;
+		protected final List<File> files = new ArrayList<File>();
+
+		public abstract void eof();
+
+		protected void initCurrentFile(String path) {
+			currentFileContent = new LinkedList<String>();
+			currentFilePath = path;
+		}
+		protected void finishCurrentFile() {
+			if (currentFileContent == null) {
+				return;
+			}
+			files.add(new File(currentFilePath, new ListSource(currentFileContent)));
+			currentFilePath = null;
+			currentFileContent= null;
+		}
+
+		public abstract void startFile(String path);
+
+		public void addLine(String line) {
+			assert line != null;
+			assert currentFileContent != null;
+			currentFileContent.add(line.substring(0, line.length() - 1));
+		}
+
+		public List<File> getFiles() {
+			return files;
+		}
+	}
+
+	private static class EventFire extends InboundMessage {
+		public final Subscription subscription;
+
+		private EventFire(Subscription subscription) {
+			this.subscription = subscription;
+		}
+
+		public void startFile(String path) {
+			assert path == null;
+			initCurrentFile(null);
+		}
+
+		@Override
+		public void eof() {
+			finishCurrentFile();
+			Dispatching.invokeLaterOrNow(subscription.getDispatcher(), new Runnable() {
+				@Override
+				public void run() {
+					subscription.getEventCallback().call(getFiles());
+				}
+			});
+		}
+	}
+
+	private static class SentQuery extends InboundMessage {
+		Request request;
+		ResponseCallback callback;
+		Dispatcher dispatcher;
+
+		public void startFile(String path) {
+			finishCurrentFile();
+			if (path == null) {
+				assert request instanceof ApplicationRequest;
+				path = ((ApplicationRequest)request).getPath();
+			}
+			initCurrentFile(path);
+		}
+
+		public void eof() {
+			finishCurrentFile();
+			//no-operation
+		}
+
+		@Override
+		public String toString() {
+			return request.toString();
+		}
+	}
+	private Map<Integer, SentQuery> queryMap = new HashMap<Integer, SentQuery>();
+
+
+	protected final String address;
+	protected final String hostName;
+	protected final int port;
+
+	private static Pattern addressPattern = Pattern.compile("^([^:]*)(:([0-9]+))?$");
+
+	public ClientConnection(String address) {
+		assert address != null;
+		this.address = address;
+		Matcher matcher = addressPattern.matcher(address);
+		if (!matcher.matches()) {
+			log.fatal("invalid address: " + address);
+			hostName = null;
+			port = 0;
+			return;
+		}
+		hostName = matcher.group(1);
+		port = matcher.group(3) != null ? Integer.parseInt(matcher.group(3)) : 9009;
+	}
+
+	private SentQuery currentlySentQuery;
+
+	public void send(Request request, ResponseCallback callback) {
+		send(request, AtOnceDispatcher.instance, callback);
+	}
+
+	public void send(Request request, Dispatcher dispatcher, ResponseCallback callback) {
+
+		if (!isConnected()) {
+			log.fatal("not connected");
+			return;
+		}
+		final SentQuery sentQuery = new SentQuery();
+		sentQuery.request = request;
+		sentQuery.callback = callback;
+		sentQuery.dispatcher = dispatcher;
+
+		senderThread.invokeLater(new Runnable(){
+			@Override
+			public void run() {
+				synchronized (ClientConnection.this) {
+
+					while (!(requestIdEnabled || currentlySentQuery == null)) {
+						try {
+							ClientConnection.this.wait();
+						} catch (InterruptedException ignored) {
+							break;
+						}
+					}
+				}
+				Integer id = stashQuery(sentQuery);
+				String command = sentQuery.request.getCommand();
+				StringBuilder message = new StringBuilder();
+				message.append(command);
+				if (id != null) {
+					message.append(" ").append(id);
+				}
+				sentQuery.request.construct(message);
+				String out = message.toString();
+
+				output.println(out);
+				log.debug("sending query: " + out);
+
+			}
+		});
+		/*
+		synchronized (this) {
+			log.debug("queueing query: " + query);
+			queryQueue.offer(sentQuery);
+			notifyAll();
+		}
+		*/
+	}
+
+
+	@Override
+	public String toString() {
+		return address;
+	}
+
+	public void subscribe(final String path, final SubscriptionCallback callback) {
+		send(new RegistrationRequest().setPath(path), new ResponseCallback() {
+			@Override
+			public void process(Response response) {
+				if (!response.getOk()) {
+					log.error("failed to register on event: " + path);
+					callback.subscribed(null);
+					return;
+				}
+				assert response.getFiles().isEmpty();
+				Subscription subscription = new Subscription(ClientConnection.this, path, response.getComment());
+				log.debug("registered on event: " + subscription);
+				synchronized (subscriptions) {
+					subscriptions.put(subscription.getRegisteredPath(), subscription);
+				}
+				subscription.setEventCallback(callback.subscribed(subscription));
+				if (subscription.getEventCallback() == null) {
+					log.info("subscription for " + path + " aborted");
+					subscription.unsubscribe(new LoggingStateCallback(log, "abort subscription"));
+				}
+			}
+		});
+	}
+
+	public void negotiateProtocolVersion(StateFunctor stateFunctor) {
+		protocolVersion = -1;
+		sendQueryVersion(1, stateFunctor);
+	}
+
+	public void sendQueryVersion(final int version, final StateFunctor stateFunctor) {
+		send(new VersionRequest().version(version), new StateCallback() {
+			@Override
+			public void call(Exception e) {
+				if (e != null) {
+					log.fatal("failed to upgrade protocol to version: " + version);
+					return;
+				}
+				protocolVersion = version;
+				if (version < 4) {
+					/** it is an implicit loop here*/
+					sendQueryVersion(version + 1, stateFunctor);
+					return;
+				}
+				send(new UseRequest().feature("request_id"), new StateCallback() {
+					@Override
+					public void call(Exception e) {
+						requestIdEnabled = e == null;
+						/*
+						synchronized (ClientConnection.this) {
+							ClientConnection.this.notifyAll();
+						}
+						*/
+						if (!requestIdEnabled) {
+							log.fatal("protocol negotiation failed");
+							stateFunctor.call(new Exception("protocol negotiation failed", e));
+							return;
+						}
+						stateFunctor.call(null);
+					}
+				});
+
+			}
+		});
+	}
+
+
+	private synchronized SentQuery fetchQuery(Integer id, boolean remove) {
+		if (id == null) {
+			if (requestIdEnabled) {
+				return null;
+			}
+			SentQuery result = currentlySentQuery;
+			if (remove) {
+				currentlySentQuery = null;
+				notifyAll();
+			}
+			return result;
+		}
+		if (queryMap.containsKey(id)) {
+			SentQuery result = queryMap.get(id);
+			if (remove) {
+				queryMap.remove(id);
+			}
+			return result;
+		}
+		return null;
+	}
+
+	private int nextQueryId = 0;
+
+	private Integer stashQuery(SentQuery sentQuery) {
+		if (!requestIdEnabled) {
+			currentlySentQuery = sentQuery;
+			return null;
+		}
+		queryMap.put(nextQueryId, sentQuery);
+		return nextQueryId++;
+	}
+
+	protected void processMessage(InboundMessage inboundMessage) throws Exception {
+		if (inboundMessage == null) {
+			log.error("failed to use any inbound message");
+			return;
+		}
+
+		String line;
+		while (!(line = getLine()).startsWith("eof")) {
+			// log.debug("line: " + line);
+			inboundMessage.addLine(line);
+		}
+		inboundMessage.eof();
+	}
+
+	protected void processEvent(String rest) throws Exception {
+		Matcher matcher = eventPattern.matcher(rest);
+		if (!matcher.matches()) {
+			log.error("invalid event line: " + rest);
+			return;
+		}
+		Subscription subscription = subscriptions.get(matcher.group(1));
+		if (subscription == null) {
+			log.error("non subscribed event: " + matcher.group(1));
+			return;
+		}
+		EventFire event = new EventFire(subscription);
+		event.startFile(null);
+		processMessage(event);
+	}
+
+
+	protected void processMessageStartingWith(String line) throws Exception {
+		Pair<String, String> command = Strings.splitIntoPair(line, ' ', "\n");
+		if (command.first.equals("event")) {
+			processEvent(command.second);
+			return;
+		}
+		Pair<Integer, String> rest = parseRest(command.second);
+
+		if (command.first.equals("file")) {
+			SentQuery sentQuery = fetchQuery(rest.first, false);
+			sentQuery.startFile(rest.second);
+			processMessage(sentQuery);
+			return;
+		}
+
+		SentQuery sentQuery = fetchQuery(rest.first, true);
+		if (sentQuery == null) {
+			return;
+		}
+		log.debug("parsing response for request " + sentQuery);
+
+		final Response response = new Response(command.first.equals("ok"), rest.second, sentQuery.getFiles());
+		final ResponseCallback callback = sentQuery.callback;
+
+		Dispatching.invokeLaterOrNow(sentQuery.dispatcher, new Runnable() {
+			@Override
+			public void run() {
+				callback.process(response);
+			}
+		});
+	}
+
+	@Override
+	protected void receiverThreadRoutine() throws Exception {
+		while (connected) {
+			processMessageStartingWith(getLine());
+		}
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 84)
@@ -1,5 +1,5 @@
 package com.framsticks.communication;
 
-import com.framsticks.util.Pair;
+import com.framsticks.util.lang.Pair;
 import org.apache.log4j.Logger;
 import java.io.BufferedReader;
@@ -15,5 +15,5 @@
 public abstract class Connection {
 
-	protected final static Logger LOGGER = Logger.getLogger(Connection.class);
+	protected final static Logger log = Logger.getLogger(Connection.class);
 
 	protected PrintWriter output = null;
@@ -28,5 +28,5 @@
 	protected int protocolVersion = -1;
 
-	protected final com.framsticks.util.Thread senderThread = new com.framsticks.util.Thread();
+	protected final com.framsticks.util.dispatching.Thread senderThread = new com.framsticks.util.dispatching.Thread();
 	protected Thread receiverThread;
 
@@ -40,6 +40,6 @@
 			connected = false;
 
-            senderThread.interrupt();
-            senderThread.join();
+			senderThread.interrupt();
+			senderThread.join();
 			if (receiverThread != null) {
 				receiverThread.interrupt();
@@ -64,7 +64,7 @@
 			}
 
-			LOGGER.info("connection closed");
+			log.info("connection closed");
 		} catch (Exception e) {
-			LOGGER.error(e);
+			log.error(e);
 		}
 
@@ -77,80 +77,80 @@
 
 
-    protected final Pair<Integer, String> parseRest(String rest) {
-        Matcher matcher = (requestIdEnabled ? requestIdEnabledPattern : requestIDisabledPattern).matcher(rest);
-        if (!matcher.matches()) {
-            LOGGER.fatal("unmatched first line of input: " + rest);
-            return null;
-        }
-        return new Pair<Integer, String>(requestIdEnabled ? Integer.parseInt(matcher.group(1)) : null, matcher.group(requestIdEnabled ? 2 : 1));
-    }
+	protected final Pair<Integer, String> parseRest(String rest) {
+		Matcher matcher = (requestIdEnabled ? requestIdEnabledPattern : requestIDisabledPattern).matcher(rest);
+		if (!matcher.matches()) {
+			log.fatal("unmatched first line of input: " + rest);
+			return null;
+		}
+		return new Pair<Integer, String>(requestIdEnabled ? Integer.parseInt(matcher.group(1)) : null, matcher.group(requestIdEnabled ? 2 : 1));
+	}
 
-    static final int BUFFER_LENGTH = 1024;
+	static final int BUFFER_LENGTH = 1024;
 
-    int readChars = 0;
-    int iterator = 0;
-    int bufferStart = 0;
-    char[] readBuffer = new char[BUFFER_LENGTH];
+	int readChars = 0;
+	int iterator = 0;
+	int bufferStart = 0;
+	char[] readBuffer = new char[BUFFER_LENGTH];
 
-    protected String getLine() throws Exception {
-        StringBuilder lineBuffer = new StringBuilder();
-        while (!Thread.interrupted()) {
-            while (iterator < readChars) {
-                if (readBuffer[iterator] != '\n') {
-                    ++iterator;
-                    continue;
-                }
-                lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart + 1);
-                ++iterator;
-                bufferStart = iterator;
-                return lineBuffer.toString();
-            }
-            lineBuffer.append(readBuffer, bufferStart, readChars - bufferStart);
+	protected String getLine() throws Exception {
+		StringBuilder lineBuffer = new StringBuilder();
+		while (!Thread.interrupted()) {
+			while (iterator < readChars) {
+				if (readBuffer[iterator] != '\n') {
+					++iterator;
+					continue;
+				}
+				lineBuffer.append(readBuffer, bufferStart, iterator - bufferStart + 1);
+				++iterator;
+				bufferStart = iterator;
+				return lineBuffer.toString();
+			}
+			lineBuffer.append(readBuffer, bufferStart, readChars - bufferStart);
 
-            readChars = 0;
-            while (readChars == 0) {
-                try {
-                    readChars = input.read(readBuffer);
-                } catch (SocketTimeoutException ignored) {
-                    //timeout - continue
-                }
-            }
-            iterator = 0;
-            bufferStart = 0;
-        }
-        throw new InterruptedException();
-    }
+			readChars = 0;
+			while (readChars == 0) {
+				try {
+					readChars = input.read(readBuffer);
+				} catch (SocketTimeoutException ignored) {
+					//timeout - continue
+				}
+			}
+			iterator = 0;
+			bufferStart = 0;
+		}
+		throw new InterruptedException();
+	}
 
-    protected abstract void receiverThreadRoutine() throws Exception;
+	protected abstract void receiverThreadRoutine() throws Exception;
 
-    protected void runThreads() {
-        try {
-            output = new PrintWriter(socket.getOutputStream(), true);
-            input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
-        } catch (IOException e) {
-            LOGGER.error("buffer creation failure");
-            close();
-            return;
-        }
+	protected void runThreads() {
+		try {
+			output = new PrintWriter(socket.getOutputStream(), true);
+			input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
+		} catch (IOException e) {
+			log.error("buffer creation failure");
+			close();
+			return;
+		}
 
-        senderThread.setName(this + "-sender");
-        receiverThread = new Thread(new Runnable() {
-            @Override
-            public void run() {
-                try {
-                    receiverThreadRoutine();
-                } catch (InterruptedException ignored) {
-                    LOGGER.debug("receiver thread interrupted");
-                } catch (Exception e) {
-                    LOGGER.error("error: " + e);
-                    close();
-                }
-            }
-        });
-        receiverThread.setName(this + "-receiver");
+		senderThread.setName(this + "-sender");
+		receiverThread = new Thread(new Runnable() {
+			@Override
+			public void run() {
+				try {
+					receiverThreadRoutine();
+				} catch (InterruptedException ignored) {
+					log.debug("receiver thread interrupted");
+				} catch (Exception e) {
+					log.error("error: " + e);
+					close();
+				}
+			}
+		});
+		receiverThread.setName(this + "-receiver");
 
-        senderThread.start();
-        receiverThread.start();
-    }
+		senderThread.start();
+		receiverThread.start();
+	}
 
 
Index: java/main/src/main/java/com/framsticks/communication/EventCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/EventCallback.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/EventCallback.java	(revision 84)
@@ -1,5 +1,3 @@
 package com.framsticks.communication;
-
-import com.framsticks.params.SourceInterface;
 
 import java.util.List;
Index: java/main/src/main/java/com/framsticks/communication/Request.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Request.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/communication/Request.java	(revision 84)
@@ -2,8 +2,4 @@
 
 import com.framsticks.communication.queries.*;
-
-import java.util.Collection;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
 
 /**
@@ -12,5 +8,5 @@
 public abstract class Request {
 
-    public static void quoteValue(StringBuilder builder, String value) {
+	public static void quoteValue(StringBuilder builder, String value) {
 		String quote = ((value.indexOf(' ') > 0) || (value.length() == 0) ? "\"" : "");
 		builder.append(quote).append(value).append(quote);
@@ -19,5 +15,5 @@
 	public abstract String getCommand();
 
-    protected abstract StringBuilder construct(StringBuilder buffer);
+	protected abstract StringBuilder construct(StringBuilder buffer);
 	//private static Pattern queryPattern = Pattern.compile("^(\\S+)\\s+(\\S+)(?:\\s+(\\S+))?$");
 
@@ -35,21 +31,21 @@
 			return new CallRequest();
 		}
-        if (type.equals("reg")) {
-            return new RegistrationRequest();
-        }
-        if (type.equals("use")) {
-            return new UseRequest();
-        }
-        if (type.equals("version")) {
-            return new VersionRequest();
-        }
-        return null;
+		if (type.equals("reg")) {
+			return new RegistrationRequest();
+		}
+		if (type.equals("use")) {
+			return new UseRequest();
+		}
+		if (type.equals("version")) {
+			return new VersionRequest();
+		}
+		return null;
 	}
 
-    public abstract void parseRest(String rest);
+	public abstract void parseRest(String rest);
 
-    @Override
-    public String toString() {
-        return construct(new StringBuilder().append(getCommand())).toString();
-    }
+	@Override
+	public String toString() {
+		return construct(new StringBuilder().append(getCommand())).toString();
+	}
 }
